Index: src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java	(revision 4080)
@@ -39,6 +39,9 @@
 
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+
 /**
  * A class to asyncronously force the replication of each server
  * that has an entry in the xml_replication table.  When run,
@@ -49,7 +52,6 @@
 public class ForceReplicationHandler implements Runnable
 {
   private Thread btThread;
-  private MetaCatUtil util = new MetaCatUtil();
   private String docid;
   private String action;
   private boolean xmlDocument;
@@ -146,223 +148,198 @@
   {
 
     
-      // URL for notifcation
-      URL comeAndGetIt = null;
-      // If no server in xml_replication table, metacat don't need do anything
-      if (serverLists.isEmpty())
-      {
-        return;
-      }
+	    // URL for notifcation
+	    URL comeAndGetIt = null;
+		// If no server in xml_replication table, metacat don't need do anything
+		if (serverLists.isEmpty()) {
+			return;
+		}
 
-      // Thread seelping for some seconds to make sure the document was insert
-      // into the database before we send force replication request
-      int sleepTime = Integer.parseInt
-                         (MetaCatUtil.getOption("forcereplicationwaitingtime"));
-      try
-      {
-        Thread.sleep(sleepTime);
-      }
-      catch(Exception ee)
-      {
-        logMetacat.error("Couldn't sleep in force replication");
-      }
-      logMetacat.info("notification server:"+notificationServer);
-      // Check every server in the serverlists
-      for (int i=0; i<serverLists.size(); i++)
-      {
-        //Set comeAndGetIt null
-        comeAndGetIt = null;
-         // Get ReplicationServer object in index i
-        ReplicationServer replicationServer = serverLists.serverAt(i);
-        // Get this ReplicationServer 's name
-        String server = replicationServer.getServerName();
-        try
-        {
-        
+		// Thread seelping for some seconds to make sure the document was insert
+		// into the database before we send force replication request
+		int sleepTime;
+		try {
+			sleepTime = Integer.parseInt(PropertyService
+					.getProperty("forcereplicationwaitingtime"));
+			Thread.sleep(sleepTime);
+		} catch (Exception ee) {
+			logMetacat.error("Couldn't sleep in force replication");
+		}
+		logMetacat.info("notification server:" + notificationServer);
+		// Check every server in the serverlists
+		for (int i = 0; i < serverLists.size(); i++) {
+			//Set comeAndGetIt null
+			comeAndGetIt = null;
+			// Get ReplicationServer object in index i
+			ReplicationServer replicationServer = serverLists.serverAt(i);
+			// Get this ReplicationServer 's name
+			String server = replicationServer.getServerName();
+			try {
 
-        // If the server is the notification server, we don't notify it back
-        // again, if server is null we don't replication it
-        if (server!=null && !server.equals(notificationServer))
-        {
+				// If the server is the notification server, we don't notify it back
+				// again, if server is null we don't replication it
+				if (server != null && !server.equals(notificationServer)) {
 
-          if(dbactionFlag)
-          {
-            // xml documents and server can replicate xml doucment
-            if (xmlDocument && replicationServer.getReplication())
-            {
-              // If this docid's homeserver is localhost, replicate it
-              if (homeServerCode==1)
-              {
-                MetacatReplication.replLog("force xml replicating to "
-                                                                    + server);
-                comeAndGetIt = new URL("https://" + server +
-                                 "?action=forcereplicate&server=" +
-                                  util.getLocalReplicationServerName()+
-                                 "&docid=" + docid + "&dbaction=" +
-                                  action);
-                //over write the url for delete
-                if (action != null && action.equals(DELETE))
-                {
-                  comeAndGetIt = new URL("https://" + server + "?action=" +
-                                   MetacatReplication.FORCEREPLICATEDELETE +
-                                  "&docid=" + docid +"&server="+ util.getLocalReplicationServerName());
+					if (dbactionFlag) {
+						// xml documents and server can replicate xml doucment
+						if (xmlDocument && replicationServer.getReplication()) {
+							// If this docid's homeserver is localhost, replicate it
+							if (homeServerCode == 1) {
+								MetacatReplication.replLog("force xml replicating to "
+										+ server);
+								comeAndGetIt = new URL("https://" + server
+										+ "?action=forcereplicate&server="
+										+ MetaCatUtil.getLocalReplicationServerName()
+										+ "&docid=" + docid + "&dbaction=" + action);
+								//over write the url for delete
+								if (action != null && action.equals(DELETE)) {
+									comeAndGetIt = new URL("https://" + server
+											+ "?action="
+											+ MetacatReplication.FORCEREPLICATEDELETE
+											+ "&docid=" + docid + "&server="
+											+ MetaCatUtil.getLocalReplicationServerName());
 
-                }
-              }//if servercode==1
-              else if (replicationServer.getHub()||
-                   server.equals(MetacatReplication.
-                                  getServerNameForServerCode(homeServerCode)))
-              {
-                // If the docid's home server is not local host, but local host
-                // is a hub of this server, replicate the docid too.
-                // If the server is homeserver of the docid, replication it too
-                MetacatReplication.replLog("force xml replicating to "
-                                                                    + server);
-                comeAndGetIt = new URL("https://" + server +
-                                 "?action=forcereplicate&server=" +
-                                 util.getLocalReplicationServerName() +
-                                 "&docid=" + docid + "&dbaction=" +
-                                  action);
-                //over write the url for delete
-               if (action != null && action.equals(DELETE))
-               {
-                  comeAndGetIt = new URL("https://" + server + "?action=" +
-                            MetacatReplication.FORCEREPLICATEDELETE +
-                           "&docid=" + docid+"&server="+ util.getLocalReplicationServerName());
+								}
+							}//if servercode==1
+							else if (replicationServer.getHub()
+									|| server.equals(MetacatReplication
+											.getServerNameForServerCode(homeServerCode))) {
+								// If the docid's home server is not local host, but local host
+								// is a hub of this server, replicate the docid too.
+								// If the server is homeserver of the docid, replication it too
+								MetacatReplication.replLog("force xml replicating to "
+										+ server);
+								comeAndGetIt = new URL("https://" + server
+										+ "?action=forcereplicate&server="
+										+ MetaCatUtil.getLocalReplicationServerName()
+										+ "&docid=" + docid + "&dbaction=" + action);
+								//over write the url for delete
+								if (action != null && action.equals(DELETE)) {
+									comeAndGetIt = new URL("https://" + server
+											+ "?action="
+											+ MetacatReplication.FORCEREPLICATEDELETE
+											+ "&docid=" + docid + "&server="
+											+ MetaCatUtil.getLocalReplicationServerName());
 
-                }
-              }//else
+								}
+							}//else
 
-            }//if xmlDocument
-            //It is data file and configured to handle data replication
-            else if (replicationServer.getDataReplication())
-            {
-              // If the docid's home server is local host, replicate the docid
-              if (homeServerCode==1)
-              {
-                MetacatReplication.replLog("force data replicating to "
-                                                                      + server);
-                comeAndGetIt = new URL("https://" + server +
-                                 "?action=forcereplicatedatafile&server=" +
-                                 util.getLocalReplicationServerName() +
-                                 "&docid=" + docid + "&dbaction=" +
-                                  action);
-                //over write the url for delete
-               if (action != null && action.equals(DELETE))
-               {
-                 comeAndGetIt = new URL("https://" + server + "?action=" +
-                                 MetacatReplication.FORCEREPLICATEDELETE +
-                                 "&docid=" + docid +"&server="+ util.getLocalReplicationServerName());
+						}//if xmlDocument
+						//It is data file and configured to handle data replication
+						else if (replicationServer.getDataReplication()) {
+							// If the docid's home server is local host, replicate the docid
+							if (homeServerCode == 1) {
+								MetacatReplication.replLog("force data replicating to "
+										+ server);
+								comeAndGetIt = new URL("https://" + server
+										+ "?action=forcereplicatedatafile&server="
+										+ MetaCatUtil.getLocalReplicationServerName()
+										+ "&docid=" + docid + "&dbaction=" + action);
+								//over write the url for delete
+								if (action != null && action.equals(DELETE)) {
+									comeAndGetIt = new URL("https://" + server
+											+ "?action="
+											+ MetacatReplication.FORCEREPLICATEDELETE
+											+ "&docid=" + docid + "&server="
+											+ MetaCatUtil.getLocalReplicationServerName());
 
-               }
+								}
 
-              }//if serverCode==1
-              else if (replicationServer.getHub()||
-                server.equals(MetacatReplication.
-                                    getServerNameForServerCode(homeServerCode)))
-              {
-                // If the docid's home server is not local host, but local host
-                // is a hub of this server, replicate the docid too.
-                // If the server is homeserver of the docid replication it too
-                 MetacatReplication.replLog("force data replicating to "
-                                                                      + server);
-                comeAndGetIt = new URL("https://" + server +
-                                 "?action=forcereplicatedatafile&server=" +
-                                 util.getLocalReplicationServerName() +
-                                 "&docid=" + docid + "&dbaction=" +
-                                  action);
-                //over write the url for delete
-               if (action != null && action.equals(DELETE))
-               {
-                  comeAndGetIt = new URL("https://" + server + "?action=" +
-                         MetacatReplication.FORCEREPLICATEDELETE +
-                        "&docid=" + docid+"&server="+ util.getLocalReplicationServerName());
+							}//if serverCode==1
+							else if (replicationServer.getHub()
+									|| server.equals(MetacatReplication
+											.getServerNameForServerCode(homeServerCode))) {
+								// If the docid's home server is not local host, but local host
+								// is a hub of this server, replicate the docid too.
+								// If the server is homeserver of the docid replication it too
+								MetacatReplication.replLog("force data replicating to "
+										+ server);
+								comeAndGetIt = new URL("https://" + server
+										+ "?action=forcereplicatedatafile&server="
+										+ MetaCatUtil.getLocalReplicationServerName()
+										+ "&docid=" + docid + "&dbaction=" + action);
+								//over write the url for delete
+								if (action != null && action.equals(DELETE)) {
+									comeAndGetIt = new URL("https://" + server
+											+ "?action="
+											+ MetacatReplication.FORCEREPLICATEDELETE
+											+ "&docid=" + docid + "&server="
+											+ MetaCatUtil.getLocalReplicationServerName());
 
-               }
+								}
 
-              }//else if servercode==1
-            }//else if data file
+							}//else if servercode==1
+						}//else if data file
 
-          }//if has explicite action
-          else
-          { // has implicite action
-            MetacatReplication.replLog("force replicating (default action) to )"
-                                                + server);
-            // this docid is xml documents and can replicate xml doucment
-            if (xmlDocument && replicationServer.getReplication())
-            {
-              // If homeserver of this doicd is local, replicate it
-              if (homeServerCode ==1)
-              {
-                comeAndGetIt = new URL("https://" + server +
-                                 "?action=forcereplicate&server=" +
-                                 util.getLocalReplicationServerName()+
-                                 "&docid=" + docid);
+					}//if has explicite action
+					else { // has implicite action
+						MetacatReplication
+								.replLog("force replicating (default action) to )"
+										+ server);
+						// this docid is xml documents and can replicate xml doucment
+						if (xmlDocument && replicationServer.getReplication()) {
+							// If homeserver of this doicd is local, replicate it
+							if (homeServerCode == 1) {
+								comeAndGetIt = new URL("https://" + server
+										+ "?action=forcereplicate&server="
+										+ MetaCatUtil.getLocalReplicationServerName()
+										+ "&docid=" + docid);
 
-              }//if homeserver ==1
-              else if (replicationServer.getHub()||
-                   server.equals(MetacatReplication.
-                   getServerNameForServerCode(homeServerCode)))
-              {
-                // If home server of this docid is not local host, but local
-                // host is a hub for this server, replicate this doicd
-                // If the server is homeserver of the docid, replication it too
-                comeAndGetIt = new URL("https://" + server +
-                                 "?action=forcereplicate&server=" +
-                                 util.getLocalReplicationServerName() +
-                                 "&docid=" + docid);
+							}//if homeserver ==1
+							else if (replicationServer.getHub()
+									|| server.equals(MetacatReplication
+											.getServerNameForServerCode(homeServerCode))) {
+								// If home server of this docid is not local host, but local
+								// host is a hub for this server, replicate this doicd
+								// If the server is homeserver of the docid, replication it too
+								comeAndGetIt = new URL("https://" + server
+										+ "?action=forcereplicate&server="
+										+ MetaCatUtil.getLocalReplicationServerName()
+										+ "&docid=" + docid);
 
-              }//else if
+							}//else if
 
-            }//if xmlDoucment
-            else if (replicationServer.getDataReplication())
-            { //It is datafile and server is configured to replicate data file
+						}//if xmlDoucment
+						else if (replicationServer.getDataReplication()) { //It is datafile and server is configured to replicate data file
 
-              //if home server is local host, replicate the data file
-              if (homeServerCode ==1)
-              {
-                comeAndGetIt = new URL("https://" + server +
-                                 "?action=forcereplicatedatafile&server=" +
-                                 util.getLocalReplicationServerName() +
-                                 "&docid=" + docid);
-              }//if
-              else if (replicationServer.getHub()||
-                          server.equals(MetacatReplication.
-                          getServerNameForServerCode(homeServerCode)))
-              {
-                // If home server is not local host, but the local host is a hub
-                // For this server, replicate the data file
-                // If the server is homeserver of the docid, replication it too
-                comeAndGetIt = new URL("https://" + server +
-                                 "?action=forcereplicatedatafile&server=" +
-                                 util.getLocalReplicationServerName() +
-                                 "&docid=" + docid);
+							//if home server is local host, replicate the data file
+							if (homeServerCode == 1) {
+								comeAndGetIt = new URL("https://" + server
+										+ "?action=forcereplicatedatafile&server="
+										+ MetaCatUtil.getLocalReplicationServerName()
+										+ "&docid=" + docid);
+							}//if
+							else if (replicationServer.getHub()
+									|| server.equals(MetacatReplication
+											.getServerNameForServerCode(homeServerCode))) {
+								// If home server is not local host, but the local host is a hub
+								// For this server, replicate the data file
+								// If the server is homeserver of the docid, replication it too
+								comeAndGetIt = new URL("https://" + server
+										+ "?action=forcereplicatedatafile&server="
+										+ MetaCatUtil.getLocalReplicationServerName()
+										+ "&docid=" + docid);
 
-              }//else
-            }//else if
-          }//else has implicit action
+							}//else
+						}//else if
+					}//else has implicit action
 
-          //Make sure comeAndGetIt is not empty
-          if ( comeAndGetIt != null && !comeAndGetIt.equals(""))
-          {
-            logMetacat.warn("sending message: "
-                                                + comeAndGetIt.toString());
-            String message = MetacatReplication.getURLContent(comeAndGetIt);
-          }
-          //send out the url.  message is a dummy variable as the target of
-          //the URL never directly replies to the request.  this simply
-          //invoces a read request from the server to this local machine.
-         }//if notification server
-        }
-        catch (Exception ee)
-        {
-        	logMetacat.error("error in ForceReplicationHandler.run for server " 
-                    + server +" "+ee.getMessage());
-             ee.printStackTrace();
-        }
-      }//for
+					//Make sure comeAndGetIt is not empty
+					if (comeAndGetIt != null && !comeAndGetIt.equals("")) {
+						logMetacat.warn("sending message: " + comeAndGetIt.toString());
+						String message = MetacatReplication.getURLContent(comeAndGetIt);
+					}
+					//send out the url.  message is a dummy variable as the target of
+					//the URL never directly replies to the request.  this simply
+					//invoces a read request from the server to this local machine.
+				}//if notification server
+			} catch (Exception ee) {
+				logMetacat.error("error in ForceReplicationHandler.run for server "
+						+ server + " " + ee.getMessage());
+				ee.printStackTrace();
+			}
+		}//for
 
-   
-      logMetacat.warn("exiting ForceReplicationHandler Thread");
-  }//run
+		logMetacat.warn("exiting ForceReplicationHandler Thread");
+	}//run
 }//ForceReplication class
Index: src/edu/ucsb/nceas/metacat/util/RequestUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/RequestUtil.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/util/RequestUtil.java	(revision 4080)
@@ -0,0 +1,162 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: A Class that implements administrative methods 
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ * 
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.util;
+
+import java.io.IOException;
+import java.util.Vector;
+
+import javax.servlet.ServletContext;
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+import org.apache.log4j.Logger;
+
+public class RequestUtil {
+	
+	private static Logger logMetacat = Logger.getLogger(RequestUtil.class);
+	
+	/**
+	 * private constructor - all methods are static so there is no
+     * no need to instantiate.
+	 */
+	private RequestUtil() {}
+	
+	/**
+	 * Forward a request that was received by this servlet on to another JSP
+	 * page or servlet to continue handling the request.
+	 * 
+	 * @param request
+	 *            to be forwarded
+	 * @param response
+	 *            that can be used for writing output to the client
+	 * @param destination
+	 *            the context-relative URL to which the request is forwarded
+	 */
+	public static void forwardRequest(HttpServletRequest request,
+			HttpServletResponse response, String destination)
+			throws IOException, ServletException {
+
+		logMetacat.debug("Forwarding request to " + destination);
+		ServletContext servletContext = request.getSession()
+				.getServletContext();
+
+		servletContext.getRequestDispatcher(destination).forward(request,
+				response);
+	}
+	
+	/**
+	 * Add a list of errors to the request. The pages will pick up the errors
+	 * and display them where appropriate.
+	 * 
+	 * @param request
+	 *            the request that will get forwarded
+	 * @param errorVector
+	 *            a list of error strings
+	 */
+	public static void setRequestErrors(HttpServletRequest request,
+			Vector<String> errorVector) {
+		request.setAttribute("formErrors", "true");
+		request.setAttribute("processingErrors", errorVector);
+	}
+	
+	/**
+	 * Add a list of form errors to the request. The pages will pick up the
+	 * errors and display them where appropriate.
+	 * 
+	 * @param request
+	 *            the request that will get forwarded
+	 * @param errorVector
+	 *            a list of form error strings
+	 */
+	public static void setRequestFormErrors(HttpServletRequest request,
+			Vector<String> errorVector) {
+		request.setAttribute("formErrors", "true");
+		request.setAttribute("formFieldErrors", errorVector);
+	}
+	
+	/**
+	 * Add a list of success messages to the request. The pages will pick up the
+	 * messages and display them where appropriate.
+	 * 
+	 * @param request
+	 *            the request that will get forwarded
+	 * @param errorVector
+	 *            a list of success message strings
+	 */
+	public static void setRequestSuccess(HttpServletRequest request,
+			Vector<String> successVector) {
+		request.setAttribute("formSuccess", "true");
+		request.setAttribute("processingSuccess", successVector);
+	}
+	
+	/**
+	 * Add a list of general messages to the request. The pages will pick up the
+	 * messages and display them where appropriate.
+	 * 
+	 * @param request
+	 *            the request that will get forwarded
+	 * @param errorVector
+	 *            a list of general message strings
+	 */
+	public static void setRequestMessage(HttpServletRequest request,
+			Vector<String> messageVector) {
+		request.setAttribute("formMessage", "true");
+		request.setAttribute("processingMessage", messageVector);
+	}
+	
+	/**
+	 * Add a list of general messages to the request. The pages will pick up the
+	 * messages and display them where appropriate.
+	 * 
+	 * @param request
+	 *            the request that will get forwarded
+	 * @param errorVector
+	 *            a list of general message strings
+	 */
+	public static void clearRequestMessages(HttpServletRequest request) {
+		request.setAttribute("formMessage", null);
+		request.setAttribute("formSuccess", null);
+		request.setAttribute("formErrors", null);
+		request.setAttribute("processingMessage", null);
+		request.setAttribute("processingSuccess", null);
+		request.setAttribute("formFieldErrors", null);
+		request.setAttribute("processingErrors", null);
+	}
+	
+	/**
+	 * Add the user's login id to the session on this request
+	 * 
+	 * @param request
+	 *            the request that will get forwarded
+	 * @param userId
+	 *            the user's login id
+	 */
+	public static void setUserId(HttpServletRequest request, String userId) {
+		request.getSession().setAttribute("userId", userId);
+	}
+}

Index: src/edu/ucsb/nceas/metacat/util/UtilException.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/UtilException.java	(nonexistent)
+++ src/edu/ucsb/nceas/metacat/util/UtilException.java	(revision 4080)
@@ -0,0 +1,44 @@
+/**
+ *  '$RCSfile$'
+ *    Purpose: An Exception thrown when an error occurs because an 
+ *             AccessionNumber was invalid or used incorrectly
+ *  Copyright: 2008 Regents of the University of California and the
+ *             National Center for Ecological Analysis and Synthesis
+ *    Authors: Michael Daigle
+ *
+ *   '$Author$'
+ *     '$Date$'
+ * '$Revision$'
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+package edu.ucsb.nceas.metacat.util;
+/**
+ * Exception thrown when an error occurs in a utility method
+ */
+public class UtilException extends Exception {
+
+	private static final long serialVersionUID = -253071242028406390L;
+
+    /**
+	 * Create a new AdminException.
+	 *
+	 * @param message The error or warning message.
+	 */
+	public UtilException(String message) {
+		super(message);
+	}
+}

